#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct tramvaj
{
	char naziv[30]; //naziv sttanice
	int broj; //broj putnika u tramvaju
	struct tramvaj *sledeci;
}voz;


#define novi(x) x=(voz*)malloc(sizeof(voz))

void dodaj_voz( voz **p, char naziv[], int broj)
{
	voz *temp, *pom1;
	
	novi(temp);
	if(!temp)
	{
		printf("Losa alokacija\n");
		exit(0);
	}
	
	strcpy(temp->naziv,naziv);
	temp->broj=broj;
	
	if(*p==NULL)
	{
		temp->sledeci=temp;
		*p=temp;
	}
	else
	{
		pom1=*p;
		while(pom1->sledeci != *p) pom1=pom1->sledeci;  //pom ce da ima vrednost kraja liste
		pom1->sledeci=temp;
		temp->sledeci=*p;
	}
	
}


voz *formiraj_voz( int n)
{
	voz *p=NULL;
	char naziv[30];
	int ulaz, izlaz;  //broj putnika koji ulazi i broj putnika koji izlazi
	int i;
	int s=0; // s ce da broji putnike u vozu
	
	for(i=0; i<n; i++)
	{
		printf("Unesite naziv stanice\n");
		gets(naziv);
		printf("Unesite broj putnika koji ulaze\n");
		scanf("%d",&ulaz);
		printf("Unesite broj putnika koji izlaze\n");
		scanf("%d",&izlaz);  getchar();
		s+=ulaz-izlaz;
		printf("s je %d\n",s);
		if(i==0) dodaj_voz(&p,naziv,ulaz);
		else
		{
			if(s<0)
			{
				s=0;
				dodaj_voz(&p,naziv,0);
			}
			else dodaj_voz(&p,naziv,s);
		}
	}
	return p;
}
	
	
	
void ispis_kr_liste( voz *p)
{
	voz *pom1=p;
	
	do
	{
		printf("Naziv stanice je %s a trenutni broj putnika u vozu je %d\n",pom1->naziv,pom1->broj);
		pom1=pom1->sledeci;
	}while( pom1 != p);
}


void moze_biti_samo_jedna( voz **p, int n)
{
	int ulaz,izlaz;
	voz *pom1=*p;
	voz *pom2;
	while(n!=1)
	{
	printf("Unesite novi ulaz\n");
	scanf("%d",&ulaz);
	printf("Unesite novi izlaz\n");
	scanf("%d",&izlaz);
	
	if(pom1 == (*p) && ulaz==0 && izlaz==0) 
	{
		pom1=*p;
		*p=(*p)->sledeci;
		free(pom1);
		n--;
		break;
	}
	else
	{
	pom1=pom1->sledeci;
	if(ulaz==0 && izlaz ==0)
	{
		pom2=*p;
		while(pom2->sledeci != pom1) pom2=pom2->sledeci;
		pom2->sledeci=pom1->sledeci;
		free(pom1); 
		n--;
	}
	}
	
	}
}
		

int main()
{
	voz *p=NULL;
	int n; //broj stanica
	
	printf("Unesite broj stanica\n");
	scanf("%d",&n); 	getchar();

	
	p=formiraj_voz(n);
	
	ispis_kr_liste(p);
	
	moze_biti_samo_jedna(&p,n);
	
	ispis_kr_liste(p);
	
	return 0;
}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
