#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct fajl
{
	char naziv[30];
	float velicina;
	char ekstenzija[10];
	struct fajl *levi, *desni;
};

#define novi(x) x=(struct fajl*)malloc(sizeof(struct fajl))

void dodaj(struct fajl **p, struct fajl *temp)
{
	struct fajl *pom, *pom2;
	
	pom=(*p);
	
	if(!pom) (*p)=temp;
	else
	{
		while(pom)
		{
			pom2=pom;
			if (temp->velicina < pom->velicina) pom=pom->levi;
			else pom=pom->desni;
		}
		if(temp->velicina < pom2->velicina) pom2->levi=temp;
		else pom2->desni=temp;			
	}
}

struct fajl *form()
{
	struct fajl *p=NULL, *temp;
	
	int n,i;
	
	printf("Uneti n: ");
	scanf("%d",&n);
//	getchar();
	
	for(i=0; i<n; i++)
	{
		novi(temp);
		if(!temp)
		{
			printf("Greška pri alokaciji.\n");
			exit(1);
		}
		temp->levi=NULL;
		temp->desni=NULL;
	
		printf("Uneti ime %d. fajla: ",i+1);
		scanf("%s",temp->naziv);
		getchar();
		
		printf("Uneti veličinu fajla %s: ",temp->naziv);
		scanf("%f",&temp->velicina);
		getchar();
		
		printf("Uneti ekstenziju fajla %s: ",temp->ekstenzija);
		scanf("%s",temp->ekstenzija);
		
		dodaj(&p,temp);
	}
	
	return p;
}

void ispis(struct fajl *p)
{
	if(p)
	{
		if(p->desni) ispis(p->desni);
		printf("naziv: %s . %s zauzima prostor od %f\n",p->naziv,p->ekstenzija,p->velicina);
		if(p->levi) ispis(p->levi);
	}
}		

void novo(struct fajl **q, struct fajl *p, char *eks, float vl)
{
	if(p)
	{
		if( (strcmp(p->ekstenzija,eks)==0) && (p->velicina > vl))
		{
			novi((*q));
			(*q)->desni=NULL;
			(*q)->levi=NULL;
			(*q)->velicina=p->velicina;
			strcpy((*q)->naziv,p->naziv);
			strcpy((*q)->ekstenzija,p->ekstenzija);
		}
	
		if(p->desni) novo(q,p->desni,eks,vl);
		if(p->levi) novo(q,p->levi,eks,vl);
	}
}

int main()
{
	struct fajl *p;
	struct fajl *q;
	char eks[5];
	float vl;
	
	p=form();
	ispis(p);
	
	printf("Uneti ekstenziju: ");
	scanf("%s",eks);
	getchar();
	printf("Uneti veličinu: ");
	scanf("%f",&vl);
	
	novo(&q,p,eks,vl);
	ispis(q);
	
return 0;
}
