#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct fajl {
	char naziv[20];
	float velicina;
	char ekstenzija[20];
	struct fajl *levi,*desni;
}FAJL;

FAJL *dodaj(FAJL *p,FAJL *temp)
{
	if(p==NULL)
	{
		p=temp;
		p->levi=NULL;
		p->desni=NULL;
	}
	else
	{
		if(p->velicina<temp->velicina)
			p->desni=dodaj(p->desni,temp);
		else
			p->levi=dodaj(p->levi,temp);
	}
	return(p);
}

FAJL *kreiraj(FAJL *p,int n)
{
	FAJL *temp;
	char naziv[20];
	float velicina;
	char ekstenzija[20];
	int i;
	getchar();
	for(i=0;i<n;i++)
	{
		temp=malloc(sizeof(FAJL));
		gets(naziv);
		strcpy(temp->naziv,naziv);
		scanf("%f",&temp->velicina);
		getchar();
		gets(ekstenzija);
		strcpy(temp->ekstenzija,ekstenzija);
		p=dodaj(p,temp);
	}
	return(p);
}


FAJL *kreiraj2(FAJL *p,FAJL *q,char ekst[],float vl)
{

	if(p!=NULL && (strcmp(p->ekstenzija,ekst)==0) && p->velicina>vl) q=dodaj(q,p);
	
		
		if(p->desni) q=kreiraj2(p->desni,q,ekst,vl);
		
		if(p->levi) q=kreiraj2(p->levi,q,ekst,vl);
	
	return(q);
}

void ispis(FAJL *p)
{
	if(p!=NULL) {
		ispis(p->desni);
		printf("%s %f %s\n",p->naziv,p->velicina,p->ekstenzija);
		ispis(p->levi);
	}
}

main()
{
	FAJL *p=NULL;
	FAJL *q=NULL;
	int n,vl;
	char eks[20];
	printf("unesite n\n");
	scanf("%d",&n);
	p=kreiraj(p,n);
	ispis(p);
	printf("unesite ext:\n");
	gets(eks);
	printf("unesite vl\n");
	scanf("%d",&vl);
	q=kreiraj2(p,q,eks,vl);
	ispis(q);
}
