#include <string.h>
#include <stdio.h>
#include <stdlib.h>

typedef struct aa
{
	char ime[50];
	int broj;
	struct aa *sledeci;	
}lista;


#define novi(x) x=(lista*)malloc(sizeof(lista));



void stampajlistu(lista *p)
{
	lista *t;
	t=p;
	while(p) 
	{
		printf("Stajaliste: %s  Broj: %d\n",p->ime,p->broj);
		p=p->sledeci;
		if(p==t) break;
	}
	
}


void dodaj(lista **p,char ime[],int broj)
{
	lista *temp;
	novi(temp);
	strcpy(temp->ime,ime);
	temp->broj=broj;
	
	if((*p)==NULL) 
	{	
		(*p)=temp;
		temp->sledeci=temp;
	}
	else
	{
		lista *t;
		t=(*p);
		while(t->sledeci != (*p)) t=t->sledeci;
		
		t->sledeci=temp;
		temp->sledeci=(*p);		
	}
	
}

lista *ucitajlistu(FILE *f,int *n1)
{
	lista *p;
	p=NULL;
	int k=0;
	char ime[50];
	int n,broj;
	int ulaz=0,izlaz=0;
	fscanf(f,"%d",&n);
	while(n--)
	{
		fscanf(f,"%s%d%d",ime,&ulaz,&izlaz);
		broj = k-izlaz;
		if(0>broj) broj = 0;
		broj+=ulaz;
		k=broj;
		dodaj(&p,ime,broj);
		
	}
	
	return p;
}

lista *update(lista *p)
{
	lista *t=p;
	int ulaz,izlaz;
	int broj;
	lista *pt=NULL;
	lista *tt;
	int r=1;
	while(r || t!=p) 
	{
			r=0;
			scanf("%d%d",&ulaz,&izlaz);
			broj=t->broj  - izlaz;
			if(broj<0) broj = 0;
			broj+=ulaz;
			t->broj=broj;
		
			if(ulaz==0 && izlaz==0)
			{
				if(pt==NULL)
				{
					tt=p;
					while(tt->sledeci!=p) tt=tt->sledeci;
					
					p=p->sledeci;
					tt->sledeci=p;
					free(t);
					t=p;
					if(t->sledeci==p) r=0;
					else 	r=1;
					continue;
					
				}
				else
				{
					pt->sledeci=t->sledeci;
					free(t);
					t=pt->sledeci;
					continue;
					
				}
				
				
				
			}
	
			pt=t;
			t=t->sledeci;		
	}
	return p;
	
}

void main(int argc,char *argv[])
{
	FILE *f;
	f=fopen(argv[1],"r");
	lista *p;
	int n;
	p=ucitajlistu(f,&n);
	stampajlistu(p);
	printf("\n");
	while(p->sledeci!=p)
	{
		p=update(p);
		if(p->sledeci==p) 
		{
			p->broj=0;
			printf("Tramvaj je zavrsio smenu na na stanici: \n");
		}
		stampajlistu(p);
		printf("\n");
		
	}
	
	
}
	
	
	

