# include <stdio.h>
# include <stdlib.h>
# include <string.h>

struct tramvaj
{
char *naziv;
int bru;
int bri;
struct tramvaj *sledeci;
};

struct tramvaj *dodaj(struct tramvaj *p, char *ime, int br1, int br2)
{
	struct tramvaj *novi;
	novi=(struct tramvaj *)malloc(sizeof(struct tramvaj));
	if(novi==NULL)
	{
		printf("Greska.\n");
		exit(0);
	}
	
	novi->naziv=(char *)malloc(strlen(ime)+1);
	strcpy(novi->naziv,ime);

	novi->bru=br1;

	novi->bri=br2;

	if(p==NULL)
	{
		novi->sledeci=p;
		p=novi;
	}
	else
	{
		struct tramvaj *pom1,*pom2;
		
		pom1=p;
		while(pom1->sledeci!=p) pom1=pom1->sledeci;
		novi->sledeci=pom1->sledeci;
		pom1->sledeci=novi;
	}
	return p;
}

struct tramvaj *form()
{
	int n,i;
	int br1,br2;
	struct tramvaj *p=NULL;
	char s[50];
	printf("Unesi n: ");
	scanf("%d",&n);
	getchar();
	for(i=0;i<n;i++)
	{
		printf("Unesi naziv stanice:\n");
		scanf("%s",&s);
		printf("Unesi broj putnika koji je usao:\n");
		scanf("%d",&br1);
		printf("Unesi broj putnika koji je izasao\n");
		scanf("%d",&br2);
		p=dodaj(p,s,br1,br2);
	}
return p;
}


void ispis_liste(struct fajl *p)
{
	int i=0,j;
	struct tramvaj *pom;
	pom=p;
	if(p==NULL)
	{
		printf("Lista je prazna.\n");
	}
	else
	{
		do
		{
			if(pom->bri<i)
				j=pom->bru;
			else
				j=pom->bru-pom->bri;
			i=i+j;
			printf("Stanica je: %s\n",pom->naziv);
			printf("Uslo je %d putnika, ",pom->bru);
			printf("a izaslo je %d putnika",pom->bri);
			printf("Broj putnika u tramvaju je:%d",i);
			pom=pom->sledeci;
		} while(pom->sledeci!=p);
	}
printf("\n");
}


	
main ()
{
struct tramvaj *p;
p=form();
ispis_liste(p);
}
