#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct fajl
{
	char naziv[30];
	float vel;
	char ext[30];
	struct fajl *levi,*desni;
}fajl;

#define novi(x) x=(fajl*)malloc(sizeof(fajl));

fajl *ucitaj(fajl *p,char ff[])
{
	fajl *pom,*pom1,*pom2;
	int n,i;
	FILE *f=fopen(ff,"r");
	fscanf(f,"%d",&n);
	
	for (i=0;i<n;i++)
	{
		novi (pom);
		fscanf(f,"%s",pom->naziv);
		fscanf(f,"%f",&pom->vel);
		fscanf(f,"%s",pom->ext);
		pom->levi=pom->desni=NULL;
		if (p==NULL)
		{
			p=pom;
		}
		else
		{
			pom1=p;
			
			while (pom1!=NULL)
			{
				pom2=pom1;
				if (pom->vel>pom1->vel)
					pom1=pom1->desni;
				else
					pom1=pom1->levi;
			}
			
			if (pom->vel>pom2->vel)
				pom2->desni=pom;
			else
				pom2->levi=pom;
		}
		
	}
	return p;
	
}

void stampa(fajl *p)
{
	if (p!=NULL)
	{
		stampa(p->desni);
		printf("%s\t%0.2f\t%s\n",p->naziv,p->vel,p->ext);
		stampa(p->levi);
		
	}
	
}

fajl *s2(fajl *p,char eks[],float vl,fajl **v)
{
	
	fajl *pom1,*pom2;
	if (p!=NULL)
	{
		s2(p->desni,eks,vl,v);
		
		if ((strcmp(p->ext,eks)==0) && (p->vel>vl))
		{
			printf ("ulazi\n");
			if (v==NULL)
			{
				(*v)=p;
				(*v)->levi=(*v)->desni=NULL;
			}
			else
			{
				pom1=(*v);
				while (pom1!=NULL)
				{
					pom2=pom1;
					if (p->vel>pom1->vel)
						pom1=pom1->desni;
					else
						pom1=pom1->levi;
					
				}
				
				if (p->vel>pom2->vel)
				{
					pom2->desni=p;
					pom2=pom2->desni;
					pom2->desni=pom2->levi=NULL;
				}
				else
				{
					pom2->levi=p;
					pom2=pom2->levi;
					pom2->desni=pom2->levi=NULL;
				}
			}
			
		}
		
		s2(p->levi,eks,vl,v);
		
	}
}

main(int argc,char *argv[])
{
	fajl *p=NULL;
	p=ucitaj(p,argv[1]);
	stampa(p);
	
	char eks[30];
	float vl;
	fajl *v=NULL;
	printf("uneti eks\n");
	scanf("%s",eks);
	scanf("%f",&vl);
	p=s2(p,eks,vl,&v);
	stampa(v);
	
	
}
