#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct stajaliste
{
	char naziv[30];
	int broj_putnika;
	struct stajaliste *sledeci;
}stajaliste;

#define novi(x) x = (stajaliste *)malloc(sizeof(stajaliste))

int dodaj(stajaliste **p, int up, int ip, char naz[30],int pro)
{
	stajaliste *temp, *pom, *pp;
	
	novi(temp);
	strcpy(temp->naziv,naz);
	temp->broj_putnika = pro + up;
	
	temp->broj_putnika = temp->broj_putnika -ip;
	
	if(temp->broj_putnika < 0) temp->broj_putnika = 0;
	
	temp->sledeci = NULL;
	pp = *p;
	
	if(pp == NULL)
	{
		pp = temp;
		temp->sledeci = temp;
	}
	else if(pp->sledeci == pp)
	{
		temp->sledeci = pp->sledeci;
		pp->sledeci = temp;
	}
	else
	{
		pom = pp;
		while(pom->sledeci != pp) pom = pom->sledeci;
		
		temp->sledeci = pom->sledeci;
		pom->sledeci = temp;
	}
	
	*p = pp;
	return temp->broj_putnika;
}

int form(stajaliste **p,int n)
{
	int i,up,ip;
	char naz[30];
	
	int pro = 0;
	for(i = 0; i < n; i++)
	{
		gets(naz);
		scanf("%d",&up);
		scanf("%d",&ip);
		getchar();
		pro = dodaj(p,up,ip,naz,pro);
	}
	return pro;
}

void ispis(stajaliste *p)
{
	stajaliste *pom;
	pom = p;
	do
	{
		printf("%s\t",pom->naziv);
		printf("%d\n",pom->broj_putnika);
		pom = pom->sledeci;
	}while(pom != p);
	printf("\n");
}

/*
int kruzi(stajaliste **p, int *pro)
{
	stajaliste *pom, *pp, *pom1, *t;
	pp =*p;
	while(pom1->sledeci != pp)	pom1 = pom1->sledeci;
	if(pom1->sledeci == pp) return 1;
	int up,ip;
	pom = *p;
	while(pom->sledeci != pp)
	{
		scanf("%d",&up);
		scanf("%d",&ip);
		if(up == ip == 0)
		{
			t = pom;
			pom1->sledeci = pom->sledeci;
			pom = pom->sledeci;
			free(t);
		}
		else
		{
			pom->broj_putnika = *pro + up;
			pom->broj_putnika = pom->broj_putnika - ip;
			if(pom->broj_putnika < 0) pom->broj_putnika = 0;
			pom = pom->sledeci;
		}
	}
	*p = pom->sledeci;
	return 2;
}

*/
main()
{
	stajaliste *p = NULL;
	int n;
	int pro;
	int a;
	scanf("%d",&n);
	getchar();
	pro = form(&p,n);
	ispis(p);
	
}
	
	
