#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct stanica
{
	char naziv[20];
	int broj;
	struct stanica *sled;
};

#define novi(x) x=(struct stanica*)malloc(sizeof(struct stanica))

void dodaj(struct stanica **p, struct stanica *temp)
{
	struct stanica *poc,*tren;
	poc=(*p);
	
	if(!poc)
	{
		(*p)=temp;
		temp->sled=temp;
		if( temp->broj < 0 ) temp->broj=0;
	}
	else
	{
		tren=poc;
		while(tren->sled != poc) tren=tren->sled;
		
		if(	(tren->broj + temp->broj) < 0 ) temp->broj = 0;
		else temp->broj=tren->broj + temp->broj;

		tren->sled=temp;
		temp->sled=poc;
	}	
}

struct stanica *form()
{
	struct stanica *p=NULL,*temp;
	int n,i,ulazi,izlazi;
	
	printf("Uneti n: ");
	scanf("%d",&n);
	getchar();
	
	for(i=0; i<n; i++)
	{
		novi(temp);
		temp->sled=NULL;
		temp->broj=0;
		
		printf("Uneti naziv stajališta: ");
		scanf("%s",temp->naziv);
		getchar();
		
		printf("Koliko njih ulazi: ");
		scanf("%d",&ulazi);
		
		printf("Koliko njih izlazi: ");
		scanf("%d",&izlazi);
		
		ulazi=ulazi-izlazi;
		temp->broj=ulazi;
		
		dodaj(&p,temp);
	}
	
	return p;
}	

void ispis(struct stanica *p)
{
	struct stanica *poc;
	poc=p;
	
	do
	{
		printf("Stajalište %s",p->naziv);
		printf(" broj putnika %d\n",p->broj);
		p=p->sled;
	}while(p != poc);
}

int main()
{
	struct stanica *p;
	
	p=form();
	ispis(p);
	
return 0;
}
