#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct St
{
	char naziv[50];
	float velicina;
	char extenzija[50];
	
	struct St *levi;
	struct St *desni;
	
}stablo;

#define novi(x) x = (stablo*) malloc(sizeof(stablo))

void Ispis(stablo* p)
{
	if(p)
	{
		Ispis(p->desni);
		printf("*%s* %.2f *%s*\n",p->naziv,p->velicina,p->extenzija);
		Ispis(p->levi);
	}
}

stablo* Ucitaj()
{
	stablo* cvor;
	novi(cvor);
	cvor->levi = cvor->desni = NULL;
	
	printf("UNesite naziv fajla\n");
	scanf("%s",cvor->naziv);
	printf("UNesite velicinu fajla\n");
	scanf("%f",&(cvor->velicina));
	getchar();
	printf("Unesite extenziju fajla\n");
	scanf("%s",cvor->extenzija);
	
	//printf("*%s* %.2f *%s*\n",cvor->naziv,cvor->velicina,cvor->extenzija);
	
	return cvor;
}

void Dodaj(stablo** p, stablo* cvor)
{
	stablo *move, *store;
	
	if(*p==NULL)
	{
		printf("Dodajem koren\n");
		*p = cvor;
	}
	else
	{
		move = *p;
		while(move)
		{
			store = move;
			if(move->velicina < cvor->velicina)
				move = move->desni;
			else
				move = move->levi;
		}
		
		if(store->velicina < cvor->velicina)
			store->desni = cvor;
		else
			store->levi = cvor;
	}
}

stablo* Formiraj()
{
	stablo* p,*cvor;
	p = NULL;
	int n;
	printf("UNesite broj fajlova\n");
	scanf("%d",&n);
	getchar();
	
	while(n--)
	{
		cvor = Ucitaj();
		Dodaj(&p,cvor);
	}
	
	return p;
}

/*stablo* Pretraga(stablo *p,char* eks,float vl)
{
	if(p)
	{
		if(strcmp(p->extenzija,eks)==0 && p->velicina > vl)
			return p;
		
		Pretraga(p->desni,eks,vl);
		if(strcmp(p->extenzija,eks)==0 && p->velicina > vl)
			return p;
		Pretraga(p->levi,eks,vl);
	}
		
}

stablo* Form(stablo* p,char *eks,float vl)
{
	stablo* novo,*cvor;
	novo = NULL;
	cvor = p;
	while(1)
	{
		cvor = Pretraga(cvor,eks,vl);
		if(cvor==NULL) break;
		Dodaj(&novo,cvor);
	}
	
	return novo;
}
*/
main()
{
	stablo* p,*novo;
	p = Formiraj();
	Ispis(p);
	//Radi
	
	/*char eks[50];
	float vl;
	printf("Unesite extenziju za pretragu.\n");
		scanf("%s",eks);
	printf("Unesite velicinu za pretragu\n");
		scanf("%f",&vl);
	
	if(p->velicina < vl)
		novo = Form(p->desni,eks,vl);
	else
		novo = Form(p->levi,eks,vl);
		
	Ispis(novo);*/
}
