#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct stajaliste
{
	char *naziv;
	int broj;
	struct stajaliste *sledeci; 
};

#define novi_str(x,n) x=(char *)malloc(sizeof(char))
#define novi(x) x=(struct stajaliste *)malloc(sizeof(struct stajaliste))

void dodaj(struct stajaliste **, struct stajaliste *);
struct stajaliste *formiraj(int *);
void ispisi(struct stajaliste *);
void krece(struct stajaliste **pocetak, int n, int *prethodni);

int main(void)
{
	int n;
	struct stajaliste *pocetak;
	pocetak=formiraj(&n);
	ispisi(pocetak);
	
	return 0;
}

void dodaj(struct stajaliste **pocetak, struct stajaliste *dod)
{
	struct stajaliste *pom;
	if (!(*pocetak))
	{
		dod->sledeci=dod;
		*pocetak=dod;
	}
	else
	{
		pom=*pocetak;
		while (pom->sledeci!=*pocetak)
			pom=pom->sledeci;
		dod->sledeci=pom->sledeci;
		pom->sledeci=dod;
	}
}

void ispisi(struct stajaliste *poc)
{
	struct stajaliste *pom;
	pom=poc;
	if (pom)
	{
		do
		{
			printf("%s - %d\n",pom->naziv,pom->broj);
			pom=pom->sledeci;
		}while(pom!=poc);	
	}
}

struct stajaliste *formiraj(int *n)
{
	struct stajaliste *pocetak=NULL, *temp;
	int ulaz, izlaz;
	char str[60];
	int prethodni=0;
	int i;
	for (scanf("%d",n), i=0; i<*n ; i++)
	{
		getchar();
		scanf("%s",str);
		scanf("%d",&ulaz);
		scanf("%d",&izlaz);
		novi(temp);
		novi_str(temp->naziv,strlen(str)+1);
		strcpy(temp->naziv,str);
		if (prethodni==0)
		{
			temp->broj=ulaz;
			prethodni=temp->broj;
		}
		else
		{
			if (prethodni-izlaz<0)
			{
				temp->broj=ulaz;
				prethodni=temp->broj;
			}
			else
			{
				temp->broj=prethodni-izlaz+ulaz;
				prethodni=temp->broj;
			}
		}
		dodaj(&pocetak,temp);
	}
	return pocetak;
}
/*void krece(struct stajaliste **pocetak, int n, int *prethodni)
{
	struct stajaliste *temp, *p, *pom;
	int ulaz, izlaz;
	char str[60];
	p=pocetak;
	int i;
	for (i=0; i<n ; i++)
	{
		scanf("%d",&ulaz);
		scanf("%d",&izlaz);
		if (ulaz==0 && izlaz==0)
		{
			pom=*pocetak;
			while (pom->sledeci!=p)
				pom=pom->sledeci;
				
		}
		if (prethodni==0)
		{
			p->broj=ulaz;
			prethodni=p->broj;
		}
		else
		{
			if (prethodni-izlaz<0)
			{
				temp->broj=ulaz;
				prethodni=temp->broj;
			}
			else
			{
				temp->broj=prethodni-izlaz+ulaz;
				prethodni=temp->broj;
			}
		}
		p=p->sledeci;
	}
}*/
